
;###########     RS-232C     ###########
;AVRSPI@\͎g킸A\tgEFAŃ^C~O킹MISOɏo͂


;***********************************************************************************************
;RS-232CւPoCgM
; r18 oCg
;115.2kbpŝƂA8.68s/bit = 69.44NbN(8MHz) = 173.6NbN(20MHz)
RSSendByte:
	cli
	push	r22		;rbgJE^
	push	r23		;EFCgJE^

	
	ldi		r22,8
	
	;--------X^[grbg(0)--------
	sbi		MISO
	ldi		r23,57	;8mhz23
rssendbyte_startbit_loop: 
	dec		r23
	brne	rssendbyte_startbit_loop

	;--------f[^rbg--------
rssendbyte_databit_loop:
	sbrs	r18,0
	sbi		MISO
	sbrc	r18,0
	cbi		MISO
	lsr		r18
	
	;EFCg
	nop
	ldi		r23,55	;8MHz20
rssendbyte_databit_waitloop:
	dec		r23
	brne	rssendbyte_databit_waitloop

	;
	dec		r22
	brne	rssendbyte_databit_loop

	;--------Xgbvrbg(1)--------
	cbi		MISO
	ldi		r23,57
rssendbyte_stopbit_loop:
	dec		r23
	brne	rssendbyte_stopbit_loop



	pop		r23
	pop		r22
	sei
	ret



;***********************************************************************************************
;RS-232CւPoCg16iɂđM
; r18 oCg
RSSendHex:
	push	r22		;ʁA܂͉ʂSrbg
	push	r23		;ۑp

	mov		r23, r18

	;hi
	mov		r22, r23
	swap	r22
	andi	r22, 0x0f
	mov		r18, r22
	rcall	RSSendHexHalf

	;lo
	mov		r22, r23
	andi	r22, 0x0f
	mov		r18, r22
	rcall	RSSendHexHalf

	pop		r23
	pop		r22
	ret

;------------------------------------------------
;0-F܂ł̐RS-232C֕ɕϊđM
; r18 鐔B15ȉł邱ƁB
RSSendHexHalf:
	cpi		r18, 10
	brsh	rssendhexhalf_char

	;0-9̂Ƃ
	subi	r18, -0x30	;0x00 + 0x30 = 0x30("0")
	rjmp	rssendhexhalf_join
	
rssendhexhalf_char:
	;A-F̂Ƃ
	subi	r18, -0x37	;0x0A + 0x37 = 0x41("A")

rssendhexhalf_join:
	rcall	RSSendByte
	ret



;***********************************************************************************************
;RS-232Cփ4oCg𑗂
; r19:r18 oCg̃AhX
RSSendDWord:
	push	XL
	push	XH
	push	cnt
	
	mov		XL, r18
	mov		XH, r19

	ldi		r18, 3
	add		XL, r18
	adc		XH, ZERO
	
	ldi		cnt, 4
rssenddword_loop:
	ld		r18, X
	rcall	RSSendHex

	subi	XL, 1
	sbc		XH, ZERO

	dec		cnt
	brne	rssenddword_loop
	
	pop		cnt
	pop		XH
	pop		XL
	ret



;***********************************************************************************************
;RS-232Cփ̈悩當𑗂
; r19:r18 镶̃̈
;     r20 
RSSendText:
	push	XL
	push	XH
	
	mov		XL, r18
	mov		XH, r19

rssendtext_loop:
	ld		r18, X+
	rcall	RSSendByte
	dec		r20
	brne	rssendtext_loop
	
	pop		XH
	pop		XL
	ret



;***********************************************************************************************
;RS-232CփvÖ悩當𑗂
; r19:r18 镶̃vÖ
;     r20 
RSSendProgramText:
	push	ZL
	push	ZH
	
	mov		ZL, r18
	mov		ZH, r19
	lsl		ZL
	rol		ZH

rssendprgramtext_loop:
	lpm		r18, Z+
	rcall	RSSendByte
	dec		r20
	brne	rssendprgramtext_loop
	
	pop		ZH
	pop		ZL
	ret


;***********************************************************************************************
;RS-232C։s𑗂
RSSendCRLF:
	ldi		r18, '\r'
	rcall	RSSendByte
	ldi		r18, '\n'
	rcall	RSSendByte
	ret



